<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');
/* * **************************************************
 * 	@author		Mian Saleem                 *
 * 	@package 	Simple Forum v3.0           *
 * 	@subpackage 	admin model            *
 * ************************************************** */
class Admin_m extends CI_Model {
    
	public function __construct() 
	{
		parent::__construct();
	}

	public function count_discussions()
	{
		$options = array('Active' => '1');
		$query = $this->db->get_where('topics', $options);
		return $query->num_rows();	
	}

	public function count_posts()
	{
		$options = array('Active' => '1');
		$query = $this->db->get_where('comments', $options);
		return $query->num_rows();
	} 

	public function count_users()
	{
		$options = array('Active' => '1');
		$query = $this->db->get_where('users', $options);
		return $query->num_rows();
	}
	
	public function getEnvatoDetails() 
	{
		$q = $this->db->get('envato'); 
		  if( $q->num_rows() > 0 )
		  {
			return $q->row();
			
		  } 
		  return FALSE;
	}
	
	public function updateEnvatoSettings($username, $api_key) 
	{
		$this->db->where('id', 1);
		if($this->db->update('envato', array('envato_username' => $username, 'envato_api_key' => $api_key))) {
			return true;
		} else {
			return false;
		}
	}
	

	public function get_users()
	{
        $data = array();
		$this->db->select('id, username, email, created_on, last_login, active');
    	$this->db->order_by('active desc, id asc');

		$q = $this->db->get('users');

		if ($q->num_rows() > 0) 
		{
			foreach ($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}

		$q->free_result();
		return $data;	
	}
	
	
	public function get_faqs()
	{
        $data = array();
		$this->db->select('*');
		$this->db->order_by('question', 'asc');
        
		$q = $this->db->get('faqs');

		if($q->num_rows() > 0)
		{
            foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}
	
	public function addFaq($data) 
	{
		if($this->db->insert('faqs', $data)) {
			return true;
		} else {
			return false;
		}
	}
	
	public function getFaqByID($id) 
	{

		$q = $this->db->get_where('faqs', array('id' => $id), 1); 
		  if( $q->num_rows() > 0 )
		  {
			return $q->row();
		  } 
		
		  return FALSE;

	}
	
	public function updateFaq($id, $data = array())
	{
		
		$this->db->where('id', $id);
		if($this->db->update('faqs', $data)) {
			return true;
		} else {
			return false;
		}
	}
	
	public function deleteFAq($id) 
	{
		if($this->db->delete('faqs', array('id' => $id))) {
			return true;
		}
	return FALSE;
	}
	
	public function get_idbs()
	{
        $data = array();
		$this->db->select('idbs.id as id, item_id, version, type, items.itemName as itemname')->from('idbs')->join('items', 'idbs.item_id=items.itemID', 'left')->group_by('idbs.id');
		$this->db->order_by('item_id', 'asc');
        
		$q = $this->db->get();

		if($q->num_rows() > 0)
		{
            foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}
		


	public function get_categories()
	{
        $data = array();
		$this->db->select('*');
		$this->db->order_by('CategoryID', 'asc');
        
		$q = $this->db->get('category');

		if($q->num_rows() > 0)
		{
            foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}

	public function get_category($categoryID)
	{
        $data = array();
		$this->db->select('*');
		$this->db->limit('1');
		$this->db->where('CategoryID', $categoryID);

		$q = $this->db->get('category');
		
		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}

	public function get_user($userID)
	{
        $data = array();
		$this->db->select('*');
		$this->db->join('meta', 'meta.user_id = users.id');
		$this->db->limit('1');
		$this->db->where('users.id', $userID);

		$q = $this->db->get('users');

		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		$q->free_result();
		return $data;
	}
    
	public function get_groups()
	{
	   $data = array();
		$this->db->select('*');
		$q = $this->db->get('groups');

		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}
	
	public function get_discussions()
	{
        $data = array();
		$this->db->select('*');
		$this->db->order_by('Flagged desc, Sticky desc, Closed asc');
		$q = $this->db->get('topics');

		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}
	
	public function get_latest_discussions()
	{
        $data = array();
		$this->db->select('*');
		$this->db->order_by('CreatedTime');
		$this->db->limit(10);
		$q = $this->db->get('topics');

		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		return $data;
	}
	
	public function get_latest_users()
	{
        $data = array();
		$this->db->select('id, username, email, created_on, last_login, active');
    	$this->db->order_by('id')->limit('10');

		$q = $this->db->get('users');

		if ($q->num_rows() > 0) 
		{
			foreach ($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}

		$q->free_result();
		return $data;	
	}

	public function get_settings()
	{
		$this->db->select('*');
		$this->db->join('themes', 'themes.themeID = settings.themeID');
		$this->db->limit('1');
		$q = $this->db->get('settings');

		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}

		$q->free_result();
		return $data;
	}
	
	public function get_themes()
	{
		$this->db->select('*');
		$this->db->where('themeActive', '1');
		$q = $this->db->get('themes');

		if ($q->num_rows() > 0)
		{
			foreach($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}

		$q->free_result();
		return $data;
	}
	
	public function updateAnnouncement($ann)
	{
		
		$this->db->where('id', 1);
		if($this->db->update('settings', array( 'announcement' => $ann))) {
			return true;
		} else {
			return false;
		}
	}
	
	/*public function getCategories()
    {
        // [HOOK] Run before categories are fetched
        //do_action('pre.get.categories');
        
        $data = array();
        $this->db->select('CategoryID, parentID, slug, type, Name, Description, Active');
        $this->db->order_by('Name');
        $q = $this->db->get('category');
        
        if ($q->num_rows() >0)
        {
            foreach ($q->result_array() as $row)
            {
                $data[] = $row;
            }
        }
        
        $q->free_result();
        
        // [HOOK] Categories array returned from database
        //$data = do_action('get.categories', $data);
        
        return $data;
        
        // [HOOK] Run after everything is finished
        //do_action('post.get.categories');
    }*/
		
}