<?php if ( ! defined('BASEPATH')) exit('No direct script access allowed');

/****************************************************
* 	@author		Mian Saleem                 *
* 	@package 	Simple Forum v3.0           *
* 	@subpackage 	user model                  *
****************************************************/

class Users_m extends CI_Model{
	
    public function __construct()
    {
        parent::__construct();
    }
    	
	public function gravatar( $email, $rating = 'X', $size = '50', $default = 'http://gravatar.com/avatar.php' ) 
	{
		
        $meta = $this->ion_auth->get_user_by_email($email);
        return 'assets/img/avatars/thumbs/'.($meta->avatar ? $meta->avatar : strtolower($meta->gender).'.png');
        
            /*$default = base_url().'assets/images/avatar-blank.jpg';
		
		# Hash the email address
		$email = md5( $email );
        
		# Return the generated URL
		return "http://gravatar.com/avatar.php?gravatar_id="
			.$email."&amp;rating="
			.$rating."&amp;size="
			.$size."&amp;default="
			.$default;*/
	} 
    
    /*public function build_avatar($email, $username)
    {
        $this->sSettings = $this->topics_m->get_settings();
        
        if($this->sSettings[0]['useGravatars'] == '0')
        {
            // Build the users avatar from a file.
            $avatar = '<img class="img-polaroid img-circle" src="'.base_url().'assets/images/avatars/users/'.$email.'.jpeg" alt="'.$this->lang->line('avatarAltText').'" title="'.$username.''.$this->lang->line('avatarTitle').'" style="height: 55px; width: 55px;" >';
        }else{
            // build the users gravatar avatar.
            $avatar = '<img class="img-polaroid img-circle" src="'.$this->gravatar($email, "x", "55").'" alt="'.$this->lang->line('avatarAltText').'" title="'.$username.''.$this->lang->line('avatarTitle').'" style="height: 55px; width: 55px;" >';
        }
        if($avatar) {
		return $avatar;
		} else {
			$avatar = '<img class="img-polaroid img-circle" src="'.$this->gravatar().'" alt="'.$this->lang->line('avatarAltText').'"  style="height: 55px; width: 55px;" >';
		}
    }	*/	
    
    public function build_avatar($email, $username)
    {
        $meta = $this->ion_auth->get_user_by_email($email);
        return '<img class="img-polaroid img-circle" src="assets/img/avatars/'.($meta->avatar ? $meta->avatar : strtolower($meta->gender).'.png').'" alt="'.$this->lang->line('avatarAltText').'" title="'.$username.''.$this->lang->line('avatarTitle').'" style="height: 55px; width: 55px;" />';
    }
	
	public function get_username($id)	
	{		
        // [HOOK] before everything else is run
        do_action('pre.get.username');
        
        // [HOOK] allow plugins to modify / get the ID
        $id = do_action('get.username.id', $id);
        
		$this->db->select('username');		
		$options = array('id' => $id);		
		$q = $this->db->get_where('users', $options, 1);				
		
		if ($q->num_rows() > 0) 
		{
			foreach ($q->result_array() as $row) 
			{				
				$data[] = $row;			
			}		
		}				
		
		$q->free_result();
        
        // [HOOK] modify the returned username
        $returned = do_action('get.username', $row['username']);		
		
		return $returned;
        
        // [HOOK] run after everything else
        do_action('post.get.username');        	
	}

	public function get_email($username)
	{
        // [HOOK] before everything else is run
        do_action('pre.get.email');
        
        // [HOOK] allow plugins to modify / get the username
        $username = do_action('get.email.username', $username);
        
		$this->db->select('email');
		$options = array('username' => $username);
		$q = $this->db->get_where('users', $options, 1);
		
		if($q->num_rows() > 0)
		{	
			foreach ($q->result_array() as $row)
			{
				$data[] = $row;
			}
		}
		
		$q->free_result();
		
        // [HOOK] modify the returned email
        $returned = do_action('get.email', $row['email']);        
        
        return $returned;
        
        // [HOOK] run after everything else
        do_action('post.get.email');           
	}
    
    public function get_userid($username)
    {
        $this->db->select('id');
        $options = array('username' => $username);
        $q = $this->db->get_where('users', $options, 1);
        
        if($q->num_rows() > 0)
        {
            foreach ($q->result_array() as $row)
            {
                $data[] = $row;
            }
        }
        
        $q->free_result();
        return $row['id'];
    }
		
	public function user_profile($username)	
	{		
        // [HOOK] before everything else is run
        do_action('pre.get.userprofile');
        
		$data = array();				
		$this->db->join('meta', 'meta.user_id = users.id');		
		$options = array('username' => $username);		
		$q = $this->db->get_where('users', $options, 1);				
			
		if($q->num_rows() > 0) 		
		{			
			foreach ($q->result_array() as $row)
			{				
				$data[] = $row;			
			}		
		}				
		
		$q->free_result();
        
        // [HOOK] the returned user profile data
        $data = do_action('get.userprofile', $data);	
        	
		return $data;
        
        // [HOOK] run after everything else
        do_action('post.get.userprofile');           	
	}
		
	public function update_settings($username)
	{
        // [HOOK] before everything else is run
        do_action('pre.update.user.settings');
            if ($_FILES['avatar']['size'] > 0) {

                $this->load->library('upload');

                $config['upload_path'] = 'assets/img/avatars';
                $config['allowed_types'] = 'gif|jpg|png';
                $config['max_size'] = '200';
                $config['max_width'] = '300';
                $config['max_height'] = '300';
                $config['overwrite'] = FALSE;

                $this->upload->initialize($config);

                if (!$this->upload->do_upload('avatar')) {

                    $error = $this->upload->display_errors();
                    $this->session->set_flashdata('error', $error);
                    redirect("forums/settings", 'refresh');
                }

                $avatar = $this->upload->file_name;

                $this->load->helper('file');
                $this->load->library('image_lib');
                $config['image_library'] = 'gd2';
                $config['source_image'] = 'assets/img/avatars/' . $avatar;
                $config['new_image'] = 'assets/img/avatars/thumbs/' . $avatar;
                $config['maintain_ratio'] = TRUE;
                $config['width'] = '55';
                $config['height'] = '55';

                $this->image_lib->clear();
                $this->image_lib->initialize($config);

                if (!$this->image_lib->resize()) {
                    echo $this->image_lib->display_errors();
                }
 
            } else {
                $avatar = FALSE;
            }
            if($avatar){
		$data = array(
			'first_name' => $this->input->post('first_name'),
			'last_name' => $this->input->post('last_name'),
			'location' => $this->input->post('location'),
			'interests' => $this->input->post('interests'),
			'occupation' => $this->input->post('occupation'),
			'gender' => $this->input->post('gender'),
                        'avatar' => $avatar
		);
                $this->session->set_userdata('avatar', $avatar);
            } else {
                $data = array(
			'first_name' => $this->input->post('first_name'),
			'last_name' => $this->input->post('last_name'),
			'location' => $this->input->post('location'),
			'interests' => $this->input->post('interests'),
			'occupation' => $this->input->post('occupation'),
			'gender' => $this->input->post('gender'),
		);
            }
        
        // [HOOK] the array of data to be manipulated before insertion
        $data = do_action('update.user.settings.meta', $data);
		
		$this->db->where('user_id', $this->session->userdata('user_id'));
		$this->db->update('meta', $data);
        
        // [HOOK] run after updating the user meta
        do_action('post.update.user.settings.meta.insert');    
		
		$this->session->set_flashdata('message', $this->lang->line('messageAccountUpdated'));
        
        // [HOOK] run after everything else
        do_action('post.update.user.settings');
        
		redirect('forums/settings/'.$username.'');	
	}
}